/* jshint esversion : 6 */


exports.isDate = v => {
    const date = moment(new Date(v));
    return date.isValid();
};


exports.isObject = function(o) {
    return (typeof o === "object" && !Array.isArray(o) && !this.isDate(o));
}.bind(exports);


exports.isPromise = p => {
    if ("object" === typeof p) {
        const c = (p.hasOwnProperty('promise') ? p.promise.constructor : p.constructor).toString().match(/^function Promise/);
        // $$state is for angular $q factory 
        return (c && c.length > 0 || p.hasOwnProperty("$$state"));
    }
};


exports.isThenableFunction = p => {
    if ("function" === typeof p) {
        const fn = p.toString();

        if (fn.match(/return?\s+?(q?\.?(promise|when|all|race|spreadResult))|(new?\s+?Promise)/g))
            return true;
        else
            return false;
    }
    return false;
};


exports.typeOf = function(o) {
    if (Array.isArray(o))
        return "array";
    else if (this.isObject(o))
        return "object";
    if (this.isDate(o))
        return "date";
    else if (null == o)
        return "null";
    else
        return typeof o;
}.bind(exports);