/* jshint esversion : 6 */


const { areEquals } = require('./checkequality');

module.exports = o => {

    if (!o._watchers)
        Object.defineProperty(o, '_watchers', { value: {} });

    if (!o.watchProperty)
        Object.defineProperty(o, "watchProperty", {
            enumerable: false,
            configurable: true,
            writable: false,
            value: function(prop, handler) {


                if (!this._watchers[prop])
                    this._watchers[prop] = { _old: this[prop], _new: this[prop], _unwatch: false };


                if (this._watchers[prop]._unwatch) {
                    delete this._watchers[prop];
                    return;
                }


                const getter = () => this._watchers[prop]._new;

                const setter = val => {
                    this._watchers[prop]._new = val;

                    if (!areEquals(this._watchers[prop]._old, val)) {
                        if (handler)
                            handler.call(this, this._watchers[prop]._old, val);
                        this._watchers[prop]._old = val;
                    }
                };

                const descriptor = Object.getOwnPropertyDescriptor(this, prop);


                // can't watch constants
                if (descriptor.configurable && delete this[prop]) {

                    Object.defineProperty(this, prop, {
                        get: getter,
                        set: setter,
                        enumerable: descriptor.enumerable,
                        configurable: true
                    });
                }
            }
        });


    if (!o.unwatch)
        Object.defineProperty(o, 'unwatch', {
            value: function(prop) {
                this._watchers[prop]._unwatch = true;
            }
        });

};