/* jshint esversion : 6 */

(function() {

    const { setWatchObjectProperty } = $app;


    if (!Object.prototype.toUpperKeys) {
        Object.defineProperty(Object.prototype, 'toUpperKeys', {
            value: function() {
                return toCase.call(this, 'toUpperCase');
            }
        });
    }



    if (!Object.prototype.toLowerKeys) {
        Object.defineProperty(Object.prototype, 'toLowerKeys', {
            value: function() {
                return toCase.call(this, 'toLowerCase');
            }
        });
    }

    function toCase(c) {
        const rg = (c === 'toLowerCase' ? /[A-Z]/g : /[a-z]/g);

        for (let k in this) {
            this[k.toString()[c]()] = this[k];
            if (k.toString().match(rg))
                delete this[k];
        }
        return this;
    }



    if (!Object.prototype.WatchProperty) {

        setWatchObjectProperty(Object.prototype);

        if (!Object.prototype.defineWatchableProperty) {
            Object.defineProperty(Object.prototype, 'defineWatchableProperty', {
                value: function(o, n, opt) {
                    opt.configurable = true;

                    if (opt.get) {
                        opt.value = opt.get();
                        delete opt.get;
                    }


                    this.defineProperty(o, n, opt);


                    if (!this._watchers)
                        Object.defineProperty(this, '_watchers', { value: {} });
                    if (!this._watchers[n])
                        this._watchers[n] = { _old: opt.value, _new: opt.value, _unwatch: false };


                }
            });
        }

    }



    if (!Object.prototype.completeAssign) {

        Object.defineProperty(Object.prototype, 'completeAssign', {
            value: function(...sources) {

                sources.forEach(source => {
                    let descriptors = Object.keys(source).reduce((descriptors, key) => {
                        descriptors[key] = Object.getOwnPropertyDescriptor(source, key);
                        return descriptors;
                    }, {});
                    // by default, Object.assign copies enumerable Symbols too
                    Object.getOwnPropertySymbols(source).forEach(sym => {
                        let descriptor = Object.getOwnPropertyDescriptor(source, sym);
                        if (descriptor.enumerable) {
                            descriptors[sym] = descriptor;
                        }
                    });
                    Object.defineProperties(this, descriptors);
                });

            }
        });

    }



}());