/* jshint esversion : 6 */

const $q = require('q');


$q.completeAssign({


    chain(cmd) {
        if (!cmd)
            cmd = 'concat';


        const { isPromise, isThenableFunction } = $app;

        const queue = [];


        const defer = $q.defer();
        defer.completeAssign({

            push(...a) {
                a.forEach(v => queue.push(v));
                return this;
            },

            exec(resolveFn, rejectFn, notifyFn) {

                const __resolved = [],
                    __rejected = [];

                const __result = (index, error, value) => {
                    const o = {
                        index: index,
                        error: error,
                        value: value
                    };
                    (error ? __rejected : __resolved).push(o);
                };


                if ('parallel' === cmd) {
                    const __exec = [];

                    if (queue.length) {
                        const __fn = (p, currIndex) => {
                            const q = $q.defer();

                            (isPromise(p) ? p : p()).then(
                                r => {
                                    q.resolve();
                                    __result(currIndex, false, r);
                                }, err => {
                                    q.resolve();
                                    __result(currIndex, true, err);
                                }, n => {
                                    const o = { index: currIndex, value: n };
                                    q.notify(o);
                                }
                            );

                            return q.promise;
                        };

                        queue.forEach((p, k) => __exec.push(__fn(p, k)))

                    } else {
                        this.resolve();
                        __exec.push(this.promise);
                    }

                    return $q.all(__exec).then(
                        () => {
                            if (resolveFn && __resolved.length)
                                resolveFn(__resolved);
                            if (rejectFn && __rejected.length)
                                rejectFn(__rejected);
                        },
                        null,
                        notifyFn
                    );

                } else if ('concat' === cmd) {

                    if (queue.length) {

                        const init = queue.shift();
                        const start = (isPromise(init) ? init : init());

                        queue.reduce((curr, next, currIndex) => {

                            return $q.when(curr,
                                r => {
                                    __result(currIndex, false, r);
                                    return (isPromise(next) ? next : next());
                                },
                                err => {
                                    __result(currIndex, true, err);
                                    return (isPromise(next) ? next : next());
                                },
                                n => {
                                    const o = { index: currIndex, value: n };
                                    this.notify(o);
                                }
                            );
                        }, start).then(
                            r => {
                                __result(queue.length, false, r);
                                this.resolve();
                            },
                            err => {
                                __result(queue.length, true, err);
                                this.resolve();
                            },
                            n => {
                                const o = { index: queue.length, value: n };
                                this.notify(o);
                            }
                        );

                    } else
                        this.resolve();



                    return this.promise.then(
                        () => {
                            if (resolveFn && __resolved.length)
                                resolveFn(__resolved);
                            if (rejectFn && __rejected.length)
                                rejectFn(__rejected);
                        },
                        null,
                        notifyFn
                    );
                }

            }

        });

        return defer;
    },



    deferredEvent: function() {
        const defer = $q.defer();

        defer.completeAssign({

            spreadResult() {
                return {
                    success(fn) {
                        $q.when(defer.promise, r => {
                            if ("object" === typeof r && r.hasOwnProperty('apply') && Array.isArray(r.apply))
                                return fn.apply(this, r.apply);
                            else
                                return fn(r);
                        });
                        return this;
                    },

                    error(fn) {
                        $q.when(defer.promise, () => {}, err => fn.call(this, err));
                        return this;
                    }

                };
            }
        });

        return defer;
    }

});


global.$q = $q;