/* jshint esversion : 6 */


(function() {


    if (!String.prototype.isUpperCase) {
        Object.defineProperty(String.prototype, 'isUpperCase', {
            value: function() {
                const str = this;

                let chk = 0;

                for (let i = 0, l = str.length; i < l; i++) {
                    if (!isNaN(str[i]))
                        continue;
                    else if (str[i] !== str[i].toUpperCase()) {
                        chk = 0;
                        break;
                    } else chk = 1;
                }

                return chk;
            }

        });
    }


    if (!String.prototype.padr) {

        // ADD PADD RIGHT TO STRING
        Object.defineProperty(String.prototype, 'padr', {
            value: function(l, padder) {
                let str = this;

                if (str.length < l)
                    for (let i = str.length; i < l; i++)
                        str += padder || '_';

                return str;
            }
        });


    }


    if (!String.prototype.padl) {

        // ADD PADD LEFT TO STRING
        Object.defineProperty(String.prototype, 'padl', {
            value: function(l, padder) {
                let str = this;

                let pad = '';
                if (str.length < l)
                    for (let i = str.length; i < l; i++)
                        pad += padder || '_';

                return pad.concat('', str);
            }
        });

    }



    if (!String.prototype.capitalize) {

        Object.defineProperty(String.prototype, 'capitalize', {
            value: function(x) {
                let str = this;

                if (!str.length)
                    return str;

                return str.split(/\s+/g).map(e => {
                    const st = e.toString().replace(/\s+/g, "");
                    const l = st.length;
                    if (l) {
                        const a = st[0].toUpperCase();
                        const s = st.substring(1, l).toLowerCase();
                        return (a + s);
                    } else
                        return st;
                }).join(typeof x !== 'undefined' ? x : ' ');
            }
        });
    }



    if (!String.prototype.chunk) {

        Object.defineProperty(String.prototype, 'chunk', {
            value: function(size) {

                const a = this;

                const l = a.length;
                const diff = l % size;
                const steps = diff ? ((l - diff) / size + 1) : (l / size);


                const _newArray = new Array(steps);

                for (let i = 0; i < steps; i++)
                    _newArray[i] = new Array(
                        (diff && i === (steps - 1)) ? diff : size
                    );


                let check = 0;
                let step = 0;
                for (let i = 0; i < l; i++) {
                    _newArray[step][check] = a[i];
                    (check < size - 1) ? check++ : (check = 0, step++);
                }

                return _newArray.map(e => e.join(''));

            }
        });


    }


}());